aboutsummaryrefslogtreecommitdiff
path: root/gen/prop/ea
diff options
context:
space:
mode:
Diffstat (limited to 'gen/prop/ea')
-rwxr-xr-xgen/prop/ea64
1 files changed, 64 insertions, 0 deletions
diff --git a/gen/prop/ea b/gen/prop/ea
new file mode 100755
index 0000000..81842c6
--- /dev/null
+++ b/gen/prop/ea
@@ -0,0 +1,64 @@
+#!/bin/sh
+
+set -e
+cd "${0%/*}/../.."
+exec >lib/unicode/prop/uprop_get_ea.c
+
+gawk '
+BEGIN {
+ FS = "( *#.*| *; +)"
+
+ print "/* This file is autogenerated by gen/prop/ea; DO NOT EDIT. */"
+ print ""
+ print "#include \"__bsearch.h\""
+ print "#include \"macros.h\""
+ print "#include \"rune.h\""
+ print "#include \"unicode/prop.h\""
+ print ""
+}
+
+/^[^#]/ {
+ n = split($1, a, /\.\./)
+ lo = strtonum("0X" a[1])
+ hi = strtonum("0X" a[n])
+
+ for (i = lo; i <= hi; i++) {
+ gsub(/^; /, "", $2)
+ props[i] = "EA_" toupper($2)
+ }
+}
+
+END {
+ print "static constexpr enum uprop_ea lookup_lat1[] = {"
+ for (i = 0; i < 0x100; i++) {
+ if (i % 8 == 0)
+ printf "\t"
+ printf "%5s,%s", props[i] ? props[i] : "EA_NA", i % 8 == 7 ? "\n" : " "
+ }
+ print "};"
+ print ""
+ print "static const struct {"
+ print "\trune lo, hi;"
+ print "\tenum uprop_ea val;"
+ print "} lookup[] = {"
+
+ for (i = 0x100; i <= 0x10FFFF; i++) {
+ if (!props[i])
+ continue
+ lo = i
+ while (props[lo] == props[i + 1])
+ i++
+ printf "\t{RUNE_C(0x%06X), RUNE_C(0x%06X), %s},\n", lo, i, props[i]
+ }
+
+ print "};"
+ print ""
+ print "__MLIB_DEFINE_BSEARCH(enum uprop_ea, lookup, EA_NA)"
+ print ""
+ print "enum uprop_ea"
+ print "uprop_get_ea(rune ch)"
+ print "{"
+ print "\treturn ch < lengthof(lookup_lat1) ? lookup_lat1[ch] : mlib_lookup(ch);"
+ print "}"
+}
+' data/DerivedEastAsianWidth.txt